KDE 4.2 PyKDE API Reference

- KDE's Python API

# ResourceManager Class Reference

`from PyKDE4.nepomuk import *`

Inherits: QObject
Namespace: Nepomuk

## Detailed Description

\class ResourceManager resourcemanager.h Nepomuk/ResourceManager

The ResourceManager is the central %KMetaData configuration point.

Author:
  Sebastian Trueg <trueg@kde.org>

## Signals

| error (QString uri, int errorCode)
| resourceModified (QString uri)

## Methods

| __init__ (self)
[Nepomuk.Resource] | allResourcesOfType (self, QUrl type)
[Nepomuk.Resource] | allResourcesOfType (self, QString type)
[Nepomuk.Resource] | allResourcesWithProperty (self, QUrl uri, Nepomuk.Variant v)
[Nepomuk.Resource] | allResourcesWithProperty (self, QString uri, Nepomuk.Variant v)
Nepomuk.Resource | createResourceFromUri (self, QString uri)
| error (self, QString uri, int errorCode)
QString | generateUniqueUri (self)
QUrl | generateUniqueUri (self, QString label)
int | init (self)
bool | initialized (self)
Soprano.Model | mainModel (self)
| notifyError (self, QString uri, int errorCode)
| removeResource (self, QString uri)
| resourceModified (self, QString uri)
| setOverrideMainModel (self, Soprano.Model model)

## Static Methods

Nepomuk.ResourceManager | instance ()

## Method Documentation

__init__ | ( |  | self ) |

[Nepomuk.Resource] allResourcesOfType | ( | self, |
|  | QUrl | type
| ) |  |  |

Retrieve a list of all resources of the specified type.

This includes Resources that are not synced yet so it might not represent exactly the state as in the RDF store.

[Nepomuk.Resource] allResourcesOfType | ( | self, |
|  | QString | type
| ) |  |  |

Deprecated:
  Use allResourcesOfType( const QString& type )

[Nepomuk.Resource] allResourcesWithProperty | ( | self, |
|  | QUrl | uri,
|  | Nepomuk.Variant | v
| ) |  |  |

Retrieve a list of all resources that have property uri defined with a value of v.

This includes Resources that are not synced yet so it might not represent exactly the state as in the RDF store.

Parameters:

  | uri | The URI identifying the property. If this URI does not include a namespace the default namespace is prepended.

Parameters:

  | v | The value all returned resources should have set as properts uri.

[Nepomuk.Resource] allResourcesWithProperty | ( | self, |
|  | QString | uri,
|  | Nepomuk.Variant | v
| ) |  |  |

Deprecated:
  Use allResourcesWithProperty( const QString& type )

Nepomuk.Resource createResourceFromUri | ( | self, |
|  | QString | uri
| ) |  |  |

Deprecated:
  Use the Resource constructor directly.

Creates a Resource object representing the data referenced by uri. The result is the same as from using the Resource.Resource( const QString&, const QString& ) constructor with an empty type.

Returns:
  The Resource representing the data at uri or an invalid Resource object if the local NEPOMUK RDF store does not contain an object with URI uri.

error | ( | self, |
|  | QString | uri,
|  | int | errorCode
| ) |  |  |

Whenever a problem occurs (like for example failed resource syncing) this signal is emitted.

Parameters:

  | uri | The resource related to the error.

Parameters:

  | errorCode | The type of the error (Resource.ErrorCode)

Signal syntax:
  `QObject.connect(source, SIGNAL("error(const QString&, int)"), target_slot)`

QString generateUniqueUri | ( |  | self ) |

Deprecated:
  Use generateUniqueUri(const QString&)

Generates a unique URI that is not used in the store yet. This method ca be used to generate URIs for virtual types such as Tag.

QUrl generateUniqueUri | ( | self, |
|  | QString | label
| ) |  |  |

Generates a unique URI that is not used in the store yet. This method ca be used to generate URIs for virtual types such as Tag.

Parameters:

  | label | A label that the algorithm should use to try to create a more readable URI.

Returns:
  A new unique URI which can be used to define a new resource.

Since:
  4.2

int init | ( |  | self ) |

Initialize the Nepomuk framework. This method will initialize the communication with the local Nepomuk-KDE services, ie. the data repository.

When using multiple threads make sure to call this method in the main thread before doing anything else.

Returns:
  0 if all necessary components could be found and -1 otherwise.

FIXME: introduce error codes and human readable translated error messages.

bool initialized | ( |  | self ) |

Returns:
  true if init() has been called successfully, ie. the KMetaData system is connected to the local RDF repository service and ready to work.

Nepomuk.ResourceManager instance | ( |  | ) |

Soprano.Model mainModel | ( |  | self ) |

Retrieve the main data storage model.

notifyError | ( | self, |
|  | QString | uri,
|  | int | errorCode
| ) |  |  |

Internal:
  Non-public API. Used by Resource to signalize errors.

removeResource | ( | self, |
|  | QString | uri
| ) |  |  |

Remove the resource denoted by uri completely.

This method is just a wrapper around Resource.remove. The result is the same.

resourceModified | ( | self, |
|  | QString | uri
| ) |  |  |

This signal gets emitted whenever a Resource changes due to a sync procedure. Be aware that modifying resources locally via the Resource.setProperty method does not result in a resourceModified signal being emitted.

Parameters:

  | uri | The URI of the modified resource.

NOT IMPLEMENTED YET

Signal syntax:
  `QObject.connect(source, SIGNAL("resourceModified(const QString&)"), target_slot)`

setOverrideMainModel | ( | self, |
|  | Soprano.Model | model
| ) |  |  |

Override the main model used for all storage. By default the main model used is the Nepomuk server main model.

Parameters:

  | model | The model to use instead of the Nepomuk server or 0 to reset.

Since:
  4.1